Index: source/Plugins/Process/POSIX/CMakeLists.txt
===================================================================
--- source/Plugins/Process/POSIX/CMakeLists.txt
+++ source/Plugins/Process/POSIX/CMakeLists.txt
@@ -10,8 +10,10 @@
   ProcessMessage.cpp
   ProcessPOSIX.cpp
   ProcessPOSIXLog.cpp
+  RegisterContextPOSIX_i386.cpp
+  RegisterContextPOSIX_x86_64.cpp
   RegisterContextFreeBSD_x86_64.cpp
-  RegisterContext_i386.cpp
   RegisterContextLinux_x86_64.cpp
-  RegisterContext_x86_64.cpp
+  RegisterContextPOSIXProcessMonitor_i386.cpp
+  RegisterContextPOSIXProcessMonitor_x86_64.cpp
   )
Index: source/Plugins/Process/POSIX/POSIXThread.cpp
===================================================================
--- source/Plugins/Process/POSIX/POSIXThread.cpp
+++ source/Plugins/Process/POSIX/POSIXThread.cpp
@@ -29,9 +29,9 @@
 #include "ProcessPOSIX.h"
 #include "ProcessPOSIXLog.h"
 #include "ProcessMonitor.h"
-#include "RegisterContext_i386.h"
-#include "RegisterContext_x86_64.h"
-#include "RegisterContextPOSIX.h"
+#include "RegisterContextPOSIX_i386.h"
+#include "RegisterContextPOSIXProcessMonitor_i386.h"
+#include "RegisterContextPOSIXProcessMonitor_x86_64.h"
 #include "RegisterContextLinux_x86_64.h"
 #include "RegisterContextFreeBSD_x86_64.h"
 
@@ -149,17 +149,17 @@
         case ArchSpec::eCore_x86_32_i386:
         case ArchSpec::eCore_x86_32_i486:
         case ArchSpec::eCore_x86_32_i486sx:
-            m_reg_context_sp.reset(new RegisterContext_i386(*this, 0));
+            m_reg_context_sp.reset(new RegisterContextPOSIXProcessMonitor_i386(*this, 0));
             break;
 
         case ArchSpec::eCore_x86_64_x86_64:
             switch (arch.GetTriple().getOS())
             {
                 case llvm::Triple::FreeBSD:
-                    m_reg_context_sp.reset(new RegisterContextFreeBSD_x86_64(*this, 0));
+                    m_reg_context_sp.reset(new RegisterContextPOSIXProcessMonitor_x86_64(*this, 0, new RegisterContextFreeBSD_x86_64()));
                     break;
                 case llvm::Triple::Linux:
-                    m_reg_context_sp.reset(new RegisterContextLinux_x86_64(*this, 0));
+                    m_reg_context_sp.reset(new RegisterContextPOSIXProcessMonitor_x86_64(*this, 0, new RegisterContextLinux_x86_64()));
                     break;
                 default:
                     assert(false && "OS not supported");
Index: source/Plugins/Process/POSIX/RegisterContextFreeBSD_x86_64.cpp
===================================================================
--- source/Plugins/Process/POSIX/RegisterContextFreeBSD_x86_64.cpp
+++ source/Plugins/Process/POSIX/RegisterContextFreeBSD_x86_64.cpp
@@ -7,8 +7,8 @@
 //
 //===---------------------------------------------------------------------===//
 
+#include "RegisterContextPOSIX_x86_64.h"
 #include "RegisterContextFreeBSD_x86_64.h"
-#include <vector>
 
 using namespace lldb_private;
 
@@ -19,13 +19,13 @@
 // Update the FreeBSD specific information (offset and size).
 #define UPDATE_GPR_INFO(reg)                                                \
 do {                                                                        \
-    GetRegisterContext()[gpr_##reg].byte_size = sizeof(GPR::reg);               \
-    GetRegisterContext()[gpr_##reg].byte_offset = GPR_OFFSET(reg);              \
+    m_register_infos[gpr_##reg].byte_size = sizeof(GPR::reg);               \
+    m_register_infos[gpr_##reg].byte_offset = GPR_OFFSET(reg);              \
 } while(false);
 
 #define UPDATE_I386_GPR_INFO(i386_reg, reg)                                 \
 do {                                                                        \
-    GetRegisterContext()[gpr_##i386_reg].byte_offset = GPR_OFFSET(reg);         \
+    m_register_infos[gpr_##i386_reg].byte_offset = GPR_OFFSET(reg);         \
 } while(false);
 
 typedef struct _GPR
@@ -58,15 +58,11 @@
     uint64_t ss;
 } GPR;
 
-// Use a singleton function to avoid global constructors in shared libraries.
-static std::vector<RegisterInfo> & GetRegisterContext () {
-    static std::vector<RegisterInfo> g_register_infos;
-    return g_register_infos;
+RegisterContextFreeBSD_x86_64::RegisterContextFreeBSD_x86_64()
+{
 }
 
-
-RegisterContextFreeBSD_x86_64::RegisterContextFreeBSD_x86_64(Thread &thread, uint32_t concrete_frame_idx):
-    RegisterContext_x86_64(thread, concrete_frame_idx)
+RegisterContextFreeBSD_x86_64::~RegisterContextFreeBSD_x86_64()
 {
 }
 
@@ -77,21 +73,17 @@
 }
 
 const RegisterInfo *
-RegisterContextFreeBSD_x86_64::GetRegisterInfo()
+RegisterContextFreeBSD_x86_64::GetRegisterInfo(const RegisterInfo *base_info)
 {
     // Allocate RegisterInfo only once
-    if (GetRegisterContext().empty())
+    if (m_register_infos.empty())
     {
         // Copy the register information from base class
-        const RegisterInfo *base_info = RegisterContext_x86_64::GetRegisterInfo();
-        if (base_info)
-        {
-            GetRegisterContext().insert(GetRegisterContext().end(), &base_info[0], &base_info[k_num_registers]);
-            // Update the FreeBSD specific register information (offset and size).
-            UpdateRegisterInfo();
-        }
+        m_register_infos.insert(m_register_infos.end(), &base_info[0], &base_info[k_num_registers]);
+        // Update the FreeBSD specific register information (offset and size).
+        UpdateRegisterInfo();
     }
-    return &GetRegisterContext()[0];
+    return &m_register_infos[0];
 }
 
 void
Index: source/Plugins/Process/POSIX/RegisterContextFreeBSD_x86_64.h
===================================================================
--- source/Plugins/Process/POSIX/RegisterContextFreeBSD_x86_64.h
+++ source/Plugins/Process/POSIX/RegisterContextFreeBSD_x86_64.h
@@ -10,23 +10,27 @@
 #ifndef liblldb_RegisterContextFreeBSD_x86_64_H_
 #define liblldb_RegisterContextFreeBSD_x86_64_H_
 
-#include "Plugins/Process/POSIX/RegisterContext_x86_64.h"
+#include <vector>
+#include "RegisterContextPOSIX.h"
 
 class RegisterContextFreeBSD_x86_64:
-    public RegisterContext_x86_64
+    public RegisterInfoInterface
 {
 public:
-    RegisterContextFreeBSD_x86_64(lldb_private::Thread &thread, uint32_t concrete_frame_idx);
+    RegisterContextFreeBSD_x86_64();
+    virtual ~RegisterContextFreeBSD_x86_64();
 
     size_t
     GetGPRSize();
 
-protected:
-    virtual const lldb_private::RegisterInfo *
-    GetRegisterInfo();
+    const lldb_private::RegisterInfo *
+    GetRegisterInfo(const lldb_private::RegisterInfo *base_info);
 
-    virtual void
+protected:
+    void
     UpdateRegisterInfo();
+
+    std::vector<lldb_private::RegisterInfo> m_register_infos;
 };
 
 #endif
Index: source/Plugins/Process/POSIX/RegisterContextLinux_x86_64.cpp
===================================================================
--- source/Plugins/Process/POSIX/RegisterContextLinux_x86_64.cpp
+++ source/Plugins/Process/POSIX/RegisterContextLinux_x86_64.cpp
@@ -8,8 +8,8 @@
 //===---------------------------------------------------------------------===//
 
 #include "llvm/Support/Compiler.h"
+#include "RegisterContextPOSIX_x86_64.h"
 #include "RegisterContextLinux_x86_64.h"
-#include <vector>
 
 using namespace lldb_private;
 
@@ -20,22 +20,22 @@
 // Update the Linux specific information (offset and size).
 #define UPDATE_GPR_INFO(reg)                                                \
 do {                                                                        \
-    GetRegisterContext()[gpr_##reg].byte_size = sizeof(GPR::reg);               \
-    GetRegisterContext()[gpr_##reg].byte_offset = GPR_OFFSET(reg);              \
+    m_register_infos[gpr_##reg].byte_size = sizeof(GPR::reg);               \
+    m_register_infos[gpr_##reg].byte_offset = GPR_OFFSET(reg);              \
 } while(false);
 
 #define UPDATE_I386_GPR_INFO(i386_reg, reg)                                 \
 do {                                                                        \
-    GetRegisterContext()[gpr_##i386_reg].byte_offset = GPR_OFFSET(reg);         \
+    m_register_infos[gpr_##i386_reg].byte_offset = GPR_OFFSET(reg);         \
 } while(false);
 
 #define DR_OFFSET(reg_index)                                                \
     (LLVM_EXTENSION offsetof(UserArea, u_debugreg[reg_index]))
 
 #define UPDATE_DR_INFO(reg_index)                                                \
 do {                                                                             \
-    GetRegisterContext()[dr##reg_index].byte_size = sizeof(UserArea::u_debugreg[0]); \
-    GetRegisterContext()[dr##reg_index].byte_offset = DR_OFFSET(reg_index);          \
+    m_register_infos[dr##reg_index].byte_size = sizeof(UserArea::u_debugreg[0]); \
+    m_register_infos[dr##reg_index].byte_offset = DR_OFFSET(reg_index);          \
 } while(false);
 
 typedef struct _GPR
@@ -69,7 +69,7 @@
     uint64_t gs;
 } GPR;
 
-typedef RegisterContext_x86_64::FXSAVE FXSAVE;
+typedef RegisterContextPOSIX_x86_64::FXSAVE FXSAVE;
 
 struct UserArea
 {
@@ -94,14 +94,11 @@
     uint64_t fault_address; // Control register CR3.
 };
 
-// Use a singleton function to avoid global constructors in shared libraries.
-static std::vector<RegisterInfo> & GetRegisterContext () {
-    static std::vector<RegisterInfo> g_register_infos;
-    return g_register_infos;
+RegisterContextLinux_x86_64::RegisterContextLinux_x86_64()
+{
 }
 
-RegisterContextLinux_x86_64::RegisterContextLinux_x86_64(Thread &thread, uint32_t concrete_frame_idx):
-    RegisterContext_x86_64(thread, concrete_frame_idx)
+RegisterContextLinux_x86_64::~RegisterContextLinux_x86_64()
 {
 }
 
@@ -112,21 +109,17 @@
 }
 
 const RegisterInfo *
-RegisterContextLinux_x86_64::GetRegisterInfo()
+RegisterContextLinux_x86_64::GetRegisterInfo(const RegisterInfo *base_info)
 {
     // Allocate RegisterInfo only once
-    if (GetRegisterContext().empty())
+    if (m_register_infos.empty())
     {
         // Copy the register information from base class
-        const RegisterInfo *base_info = RegisterContext_x86_64::GetRegisterInfo();
-        if (base_info)
-        {
-            GetRegisterContext().insert(GetRegisterContext().end(), &base_info[0], &base_info[k_num_registers]);
-            // Update the Linux specific register information (offset and size).
-            UpdateRegisterInfo();
-        }
+        m_register_infos.insert(m_register_infos.end(), &base_info[0], &base_info[k_num_registers]);
+        // Update the Linux specific register information (offset and size).
+        UpdateRegisterInfo();
     }
-    return &GetRegisterContext()[0];
+    return &m_register_infos[0];
 }
 
 void
Index: source/Plugins/Process/POSIX/RegisterContextLinux_x86_64.h
===================================================================
--- source/Plugins/Process/POSIX/RegisterContextLinux_x86_64.h
+++ source/Plugins/Process/POSIX/RegisterContextLinux_x86_64.h
@@ -10,23 +10,27 @@
 #ifndef liblldb_RegisterContextLinux_x86_64_H_
 #define liblldb_RegisterContextLinux_x86_64_H_
 
-#include "Plugins/Process/POSIX/RegisterContext_x86_64.h"
+#include <vector>
+#include "RegisterContextPOSIX.h"
 
-class RegisterContextLinux_x86_64:
-    public RegisterContext_x86_64
+class RegisterContextLinux_x86_64
+  : public RegisterInfoInterface
 {
 public:
-    RegisterContextLinux_x86_64(lldb_private::Thread &thread, uint32_t concrete_frame_idx);
+    RegisterContextLinux_x86_64();
+    virtual ~RegisterContextLinux_x86_64();
 
     size_t
     GetGPRSize();
 
-protected:
-    virtual const lldb_private::RegisterInfo *
-    GetRegisterInfo();
+    const lldb_private::RegisterInfo *
+    GetRegisterInfo(const lldb_private::RegisterInfo *base_info);
 
-    virtual void
+protected:
+    void
     UpdateRegisterInfo();
+
+    std::vector<lldb_private::RegisterInfo> m_register_infos;
 };
 
 #endif
Index: source/Plugins/Process/POSIX/RegisterContextPOSIX.h
===================================================================
--- source/Plugins/Process/POSIX/RegisterContextPOSIX.h
+++ source/Plugins/Process/POSIX/RegisterContextPOSIX.h
@@ -67,4 +67,21 @@
     bool m_watchpoints_initialized;
 };
 
+//------------------------------------------------------------------------------
+/// @class RegisterInfoInterface
+///
+/// @brief RegisterInfo interface to patch RegisterInfo structure for archs.
+class RegisterInfoInterface
+{
+public:
+    virtual ~RegisterInfoInterface() {}
+
+    virtual size_t
+    GetGPRSize() = 0;
+
+    virtual const lldb_private::RegisterInfo *
+    GetRegisterInfo(const lldb_private::RegisterInfo *base_info) = 0;
+};
+
 #endif // #ifndef liblldb_RegisterContextPOSIX_H_
+
Index: source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_i386.cpp
===================================================================
--- /dev/null
+++ source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_i386.cpp
@@ -0,0 +1,80 @@
+//===-- RegisterContextPOSIXProcessMonitor_i386.h --------------*- C++ -*-===//
+//
+//                     The LLVM Compiler Infrastructure
+//
+// This file is distributed under the University of Illinois Open Source
+// License. See LICENSE.TXT for details.
+//
+//===---------------------------------------------------------------------===//
+
+#include "lldb/Target/Thread.h"
+
+#include "ProcessPOSIX.h"
+#include "RegisterContextPOSIXProcessMonitor_i386.h"
+#include "ProcessMonitor.h"
+
+using namespace lldb_private;
+using namespace lldb;
+
+RegisterContextPOSIXProcessMonitor_i386::RegisterContextPOSIXProcessMonitor_i386(Thread &thread,
+                                                                                 uint32_t concrete_frame_idx)
+    : RegisterContextPOSIX_i386(thread, concrete_frame_idx)
+{
+}
+
+ProcessMonitor &
+RegisterContextPOSIXProcessMonitor_i386::GetMonitor()
+{
+    ProcessSP base = CalculateProcess();
+    ProcessPOSIX *process = static_cast<ProcessPOSIX*>(base.get());
+    return process->GetMonitor();
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_i386::ReadGPR()
+{
+    bool result;
+
+    ProcessMonitor &monitor = GetMonitor();
+    result = monitor.ReadGPR(m_thread.GetID(), &m_user.regs, sizeof(m_user.regs));
+    LogGPR("RegisterContextPOSIXProcessMonitor_i386::ReadGPR()");
+    return result;
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_i386::ReadFPR()
+{
+    ProcessMonitor &monitor = GetMonitor();
+    return monitor.ReadFPR(m_thread.GetID(), &m_user.i387, sizeof(m_user.i387));
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_i386::WriteGPR()
+{
+    return false;
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_i386::WriteFPR()
+{
+    return false;
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_i386::ReadRegister(const RegisterInfo *reg_info,
+                                                      RegisterValue &value)
+{
+    const uint32_t reg = reg_info->kinds[eRegisterKindLLDB];
+    ProcessMonitor &monitor = GetMonitor();
+    return monitor.ReadRegisterValue(m_thread.GetID(), GetRegOffset(reg),
+                                     GetRegisterName(reg), GetRegSize(reg), value);
+}
+
+bool RegisterContextPOSIXProcessMonitor_i386::WriteRegister(const RegisterInfo *reg_info,
+                                                            const RegisterValue &value)
+{
+    const uint32_t reg = reg_info->kinds[eRegisterKindLLDB];
+    ProcessMonitor &monitor = GetMonitor();
+    return monitor.WriteRegisterValue(m_thread.GetID(), GetRegOffset(reg),
+                                      GetRegisterName(reg), value);
+}
Index: source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_i386.h
===================================================================
--- /dev/null
+++ source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_i386.h
@@ -0,0 +1,46 @@
+//===-- RegisterContextPOSIXProcessMonitor_i386.h ---------------*- C++ -*-===//
+//
+//                     The LLVM Compiler Infrastructure
+//
+// This file is distributed under the University of Illinois Open Source
+// License. See LICENSE.TXT for details.
+//
+//===----------------------------------------------------------------------===//
+
+#ifndef liblldb_RegisterContextPOSIXProcessMonitor_i386_H_
+#define liblldb_RegisterContextPOSIXProcessMonitor_i386_H_
+
+#include "Plugins/Process/POSIX/RegisterContextPOSIX_i386.h"
+
+class RegisterContextPOSIXProcessMonitor_i386:
+    public RegisterContextPOSIX_i386
+{
+public:
+    RegisterContextPOSIXProcessMonitor_i386(lldb_private::Thread &thread,
+                                            uint32_t concrete_frame_idx);
+
+protected:
+    bool
+    ReadGPR();
+
+    bool
+    ReadFPR();
+
+    bool
+    WriteGPR();
+
+    bool
+    WriteFPR();
+
+	bool
+	ReadRegister(const lldb_private::RegisterInfo *reg_info, lldb_private::RegisterValue &value);
+
+	bool
+	WriteRegister(const lldb_private::RegisterInfo *reg_info, const lldb_private::RegisterValue &value);
+
+private:
+    ProcessMonitor &
+    GetMonitor();
+};
+
+#endif
Index: source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_x86_64.cpp
===================================================================
--- /dev/null
+++ source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_x86_64.cpp
@@ -0,0 +1,98 @@
+//===-- RegisterContextPOSIXProcessMonitor_x86_64.h ------------*- C++ -*-===//
+//
+//                     The LLVM Compiler Infrastructure
+//
+// This file is distributed under the University of Illinois Open Source
+// License. See LICENSE.TXT for details.
+//
+//===---------------------------------------------------------------------===//
+
+#include "lldb/Target/Thread.h"
+
+#include "ProcessPOSIX.h"
+#include "RegisterContextPOSIXProcessMonitor_x86_64.h"
+#include "ProcessMonitor.h"
+
+using namespace lldb_private;
+using namespace lldb;
+
+// Support ptrace extensions even when compiled without required kernel support
+#ifndef NT_X86_XSTATE
+  #define NT_X86_XSTATE 0x202
+#endif
+
+RegisterContextPOSIXProcessMonitor_x86_64::RegisterContextPOSIXProcessMonitor_x86_64(Thread &thread,
+                                                                                     uint32_t concrete_frame_idx,
+                                                                                     RegisterInfoInterface *register_info)
+    : RegisterContextPOSIX_x86_64(thread, concrete_frame_idx, register_info)
+{
+}
+
+ProcessMonitor &
+RegisterContextPOSIXProcessMonitor_x86_64::GetMonitor()
+{
+    ProcessSP base = CalculateProcess();
+    ProcessPOSIX *process = static_cast<ProcessPOSIX*>(base.get());
+    return process->GetMonitor();
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_x86_64::ReadGPR()
+{
+     ProcessMonitor &monitor = GetMonitor();
+     return monitor.ReadGPR(m_thread.GetID(), &m_gpr, GetGPRSize());
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_x86_64::ReadFPR()
+{
+    ProcessMonitor &monitor = GetMonitor();
+    if (m_fpr_type == eFXSAVE)
+        return monitor.ReadFPR(m_thread.GetID(), &m_fpr.xstate.fxsave, sizeof(m_fpr.xstate.fxsave));
+
+    if (m_fpr_type == eXSAVE)
+        return monitor.ReadRegisterSet(m_thread.GetID(), &m_iovec, sizeof(m_fpr.xstate.xsave), NT_X86_XSTATE);
+    return false;
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_x86_64::WriteGPR()
+{
+    ProcessMonitor &monitor = GetMonitor();
+    return monitor.WriteGPR(m_thread.GetID(), &m_gpr, GetGPRSize());
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_x86_64::WriteFPR()
+{
+    ProcessMonitor &monitor = GetMonitor();
+    if (m_fpr_type == eFXSAVE)
+        return monitor.WriteFPR(m_thread.GetID(), &m_fpr.xstate.fxsave, sizeof(m_fpr.xstate.fxsave));
+
+    if (m_fpr_type == eXSAVE)
+        return monitor.WriteRegisterSet(m_thread.GetID(), &m_iovec, sizeof(m_fpr.xstate.xsave), NT_X86_XSTATE);
+    return false;
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_x86_64::ReadRegister(const unsigned reg,
+                                                        RegisterValue &value)
+{
+    ProcessMonitor &monitor = GetMonitor();
+    return monitor.ReadRegisterValue(m_thread.GetID(),
+                                     GetRegisterOffset(reg),
+                                     GetRegisterName(reg),
+                                     GetRegisterSize(reg),
+                                     value);
+}
+
+bool
+RegisterContextPOSIXProcessMonitor_x86_64::WriteRegister(const unsigned reg,
+                                                         const RegisterValue &value)
+{
+    ProcessMonitor &monitor = GetMonitor();
+    return monitor.WriteRegisterValue(m_thread.GetID(),
+                                      GetRegisterOffset(reg),
+                                      GetRegisterName(reg),
+                                      value);
+}
Index: source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_x86_64.h
===================================================================
--- /dev/null
+++ source/Plugins/Process/POSIX/RegisterContextPOSIXProcessMonitor_x86_64.h
@@ -0,0 +1,47 @@
+//===-- RegisterContextPOSIXProcessMonitor_x86_64.h -------------*- C++ -*-===//
+//
+//                     The LLVM Compiler Infrastructure
+//
+// This file is distributed under the University of Illinois Open Source
+// License. See LICENSE.TXT for details.
+//
+//===----------------------------------------------------------------------===//
+
+#ifndef liblldb_RegisterContextPOSIXProcessMonitor_x86_64_H_
+#define liblldb_RegisterContextPOSIXProcessMonitor_x86_64_H_
+
+#include "Plugins/Process/POSIX/RegisterContextPOSIX_x86_64.h"
+
+class RegisterContextPOSIXProcessMonitor_x86_64:
+    public RegisterContextPOSIX_x86_64
+{
+public:
+    RegisterContextPOSIXProcessMonitor_x86_64(lldb_private::Thread &thread,
+                                              uint32_t concrete_frame_idx,
+                                              RegisterInfoInterface *register_info);
+
+protected:
+    bool
+    ReadGPR();
+
+    bool
+    ReadFPR();
+
+    bool
+    WriteGPR();
+
+    bool
+    WriteFPR();
+
+    bool
+    ReadRegister(const unsigned reg, lldb_private::RegisterValue &value);
+
+    bool
+    WriteRegister(const unsigned reg, const lldb_private::RegisterValue &value);
+
+private:
+    ProcessMonitor &
+    GetMonitor();
+};
+
+#endif
Index: source/Plugins/Process/POSIX/RegisterContextPOSIX_i386.cpp
===================================================================
--- source/Plugins/Process/POSIX/RegisterContextPOSIX_i386.cpp
+++ source/Plugins/Process/POSIX/RegisterContextPOSIX_i386.cpp
@@ -15,7 +15,7 @@
 #include "ProcessPOSIX.h"
 #include "ProcessPOSIXLog.h"
 #include "ProcessMonitor.h"
-#include "RegisterContext_i386.h"
+#include "RegisterContextPOSIX_i386.h"
 #include "RegisterContext_x86.h"
 
 using namespace lldb_private;
@@ -147,25 +147,25 @@
 
 // Computes the offset of the given GPR in the user data area.
 #define GPR_OFFSET(regname) \
-    (offsetof(RegisterContext_i386::UserArea, regs) + \
-     offsetof(RegisterContext_i386::GPR, regname))
+    (offsetof(RegisterContextPOSIX_i386::UserArea, regs) + \
+     offsetof(RegisterContextPOSIX_i386::GPR, regname))
 
 // Computes the offset of the given FPR in the user data area.
 #define FPR_OFFSET(regname) \
-    (offsetof(RegisterContext_i386::UserArea, i387) + \
-     offsetof(RegisterContext_i386::FPU, regname))
+    (offsetof(RegisterContextPOSIX_i386::UserArea, i387) + \
+     offsetof(RegisterContextPOSIX_i386::FPU, regname))
 
 // Number of bytes needed to represent a GPR.
-#define GPR_SIZE(reg) sizeof(((RegisterContext_i386::GPR*)NULL)->reg)
+#define GPR_SIZE(reg) sizeof(((RegisterContextPOSIX_i386::GPR*)NULL)->reg)
 
 // Number of bytes needed to represent a FPR.
-#define FPR_SIZE(reg) sizeof(((RegisterContext_i386::FPU*)NULL)->reg)
+#define FPR_SIZE(reg) sizeof(((RegisterContextPOSIX_i386::FPU*)NULL)->reg)
 
 // Number of bytes needed to represent the i'th FP register.
-#define FP_SIZE sizeof(((RegisterContext_i386::MMSReg*)NULL)->bytes)
+#define FP_SIZE sizeof(((RegisterContextPOSIX_i386::MMSReg*)NULL)->bytes)
 
 // Number of bytes needed to represent an XMM register.
-#define XMM_SIZE sizeof(RegisterContext_i386::XMMReg)
+#define XMM_SIZE sizeof(RegisterContextPOSIX_i386::XMMReg)
 
 #define DEFINE_GPR(reg, alt, kind1, kind2, kind3, kind4)        \
     { #reg, alt, GPR_SIZE(reg), GPR_OFFSET(reg), eEncodingUint, \
@@ -244,55 +244,47 @@
 static size_t k_num_register_infos = (sizeof(g_register_infos)/sizeof(RegisterInfo));
 #endif
 
-static unsigned GetRegOffset(unsigned reg)
+unsigned RegisterContextPOSIX_i386::GetRegOffset(unsigned reg)
 {
     assert(reg < k_num_registers && "Invalid register number.");
     return g_register_infos[reg].byte_offset;
 }
 
-static unsigned GetRegSize(unsigned reg)
+unsigned RegisterContextPOSIX_i386::GetRegSize(unsigned reg)
 {
     assert(reg < k_num_registers && "Invalid register number.");
     return g_register_infos[reg].byte_size;
 }
 
-RegisterContext_i386::RegisterContext_i386(Thread &thread,
+RegisterContextPOSIX_i386::RegisterContextPOSIX_i386(Thread &thread,
                                                      uint32_t concrete_frame_idx)
     : RegisterContextPOSIX(thread, concrete_frame_idx)
 {
 }
 
-RegisterContext_i386::~RegisterContext_i386()
+RegisterContextPOSIX_i386::~RegisterContextPOSIX_i386()
 {
 }
 
-ProcessMonitor &
-RegisterContext_i386::GetMonitor()
-{
-    ProcessSP base = CalculateProcess();
-    ProcessPOSIX *process = static_cast<ProcessPOSIX*>(base.get());
-    return process->GetMonitor();
-}
-
 void
-RegisterContext_i386::Invalidate()
+RegisterContextPOSIX_i386::Invalidate()
 {
 }
 
 void
-RegisterContext_i386::InvalidateAllRegisters()
+RegisterContextPOSIX_i386::InvalidateAllRegisters()
 {
 }
 
 size_t
-RegisterContext_i386::GetRegisterCount()
+RegisterContextPOSIX_i386::GetRegisterCount()
 {
     assert(k_num_register_infos == k_num_registers);
     return k_num_registers;
 }
 
 const RegisterInfo *
-RegisterContext_i386::GetRegisterInfoAtIndex(size_t reg)
+RegisterContextPOSIX_i386::GetRegisterInfoAtIndex(size_t reg)
 {
     assert(k_num_register_infos == k_num_registers);
     if (reg < k_num_registers)
@@ -302,22 +294,22 @@
 }
 
 size_t
-RegisterContext_i386::GetRegisterSetCount()
+RegisterContextPOSIX_i386::GetRegisterSetCount()
 {
     return k_num_register_sets;
 }
 
 const RegisterSet *
-RegisterContext_i386::GetRegisterSet(size_t set)
+RegisterContextPOSIX_i386::GetRegisterSet(size_t set)
 {
     if (set < k_num_register_sets)
         return &g_reg_sets[set];
     else
         return NULL;
 }
 
 unsigned
-RegisterContext_i386::GetRegisterIndexFromOffset(unsigned offset)
+RegisterContextPOSIX_i386::GetRegisterIndexFromOffset(unsigned offset)
 {
     unsigned reg;
     for (reg = 0; reg < k_num_registers; reg++)
@@ -330,45 +322,26 @@
 }
 
 const char *
-RegisterContext_i386::GetRegisterName(unsigned reg)
+RegisterContextPOSIX_i386::GetRegisterName(unsigned reg)
 {
     assert(reg < k_num_registers && "Invalid register offset.");
     return g_register_infos[reg].name;
 }
 
 bool
-RegisterContext_i386::ReadRegister(const RegisterInfo *reg_info,
-                                        RegisterValue &value)
-{
-    const uint32_t reg = reg_info->kinds[eRegisterKindLLDB];
-    ProcessMonitor &monitor = GetMonitor();
-    return monitor.ReadRegisterValue(m_thread.GetID(), GetRegOffset(reg),
-                                     GetRegisterName(reg), GetRegSize(reg), value);
-}
-
-bool
-RegisterContext_i386::ReadAllRegisterValues(DataBufferSP &data_sp)
+RegisterContextPOSIX_i386::ReadAllRegisterValues(DataBufferSP &data_sp)
 {
     return false;
 }
 
-bool RegisterContext_i386::WriteRegister(const RegisterInfo *reg_info,
-                                         const RegisterValue &value)
-{
-    const uint32_t reg = reg_info->kinds[eRegisterKindLLDB];
-    ProcessMonitor &monitor = GetMonitor();
-    return monitor.WriteRegisterValue(m_thread.GetID(), GetRegOffset(reg),
-                                      GetRegisterName(reg), value);
-}
-
 bool
-RegisterContext_i386::WriteAllRegisterValues(const DataBufferSP &data)
+RegisterContextPOSIX_i386::WriteAllRegisterValues(const DataBufferSP &data)
 {
     return false;
 }
 
 bool
-RegisterContext_i386::UpdateAfterBreakpoint()
+RegisterContextPOSIX_i386::UpdateAfterBreakpoint()
 {
     // PC points one byte past the int3 responsible for the breakpoint.
     lldb::addr_t pc;
@@ -381,7 +354,7 @@
 }
 
 uint32_t
-RegisterContext_i386::ConvertRegisterKindToRegisterNumber(uint32_t kind,
+RegisterContextPOSIX_i386::ConvertRegisterKindToRegisterNumber(uint32_t kind,
                                                                uint32_t num)
 {
     if (kind == eRegisterKindGeneric)
@@ -490,7 +463,7 @@
 }
 
 bool
-RegisterContext_i386::HardwareSingleStep(bool enable)
+RegisterContextPOSIX_i386::HardwareSingleStep(bool enable)
 {
     enum { TRACE_BIT = 0x100 };
     uint64_t eflags;
@@ -517,7 +490,7 @@
 }
 
 void
-RegisterContext_i386::LogGPR(const char *title)
+RegisterContextPOSIX_i386::LogGPR(const char *title)
 {
     Log *log (ProcessPOSIXLog::GetLogIfAllCategoriesSet (POSIX_LOG_REGISTERS));
     if (log)
@@ -527,25 +500,7 @@
         for (uint32_t i=0; i<k_num_gpr_registers; i++)
         {
             uint32_t reg = gpr_eax + i;
-            log->Printf("%12s = 0x%8.8" PRIx64, g_register_infos[reg].name, ((uint64_t*)&user.regs)[reg]);
+            log->Printf("%12s = 0x%8.8" PRIx64, g_register_infos[reg].name, ((uint64_t*)&m_user.regs)[reg]);
         }
     }
 }
-
-bool
-RegisterContext_i386::ReadGPR()
-{
-    bool result;
-
-    ProcessMonitor &monitor = GetMonitor();
-    result = monitor.ReadGPR(m_thread.GetID(), &user.regs, sizeof(user.regs));
-    LogGPR("RegisterContext_i386::ReadGPR()");
-    return result;
-}
-
-bool
-RegisterContext_i386::ReadFPR()
-{
-    ProcessMonitor &monitor = GetMonitor();
-    return monitor.ReadFPR(m_thread.GetID(), &user.i387, sizeof(user.i387));
-}
